package com.cusc.adas.v2x.assist.dto;

import java.util.List;

import com.cusc.adas.v2x.utils.Order;
import com.cusc.adas.v2x.utils.RefNumFlag;

/**
 * 信号灯
 * @author huangml
 *
 */
public class TrafficLightDto {
	//红绿灯控制方 式 1：固定周期；2：手动控制；3：黄闪控制，4-254： 预留
	@Order(1)
	private  short controlMode;
	//区域 ID 信号灯作用位置所在区域唯一编号,与路口 ID 一起确定 唯一路口
	@Order(2)
	private  int regionId;
	
	//路口 ID 信号灯作用位置在该区域内唯一编号,与区域 ID 一起确 定唯一路口
	@Order(3)
	private  int nodeId;
	
	//车辆所在车道 对应信号灯相 位数量
	@Order(4)
	private  int numOfLanePhase;
	//车辆所在车道 对应信号灯相 位 ID 列表
	@Order(5)
	@RefNumFlag(value="numOfLanePhase")
	private List<Short> lanePhaseIds;
	
	//车辆到前方停 止线距离
	@Order(6)
	private  int d2StopLine;
	
	//相位数量
	@Order(7)
	private  short  phaseNumber;
	
	//信号灯相位状 态
	@Order(8)
	@RefNumFlag(value="phaseNumber")
	private List<TrafficLightStatusDto> phaseState;
	
	
	
}
